/***************************************************************************

	Filename:	tufault.c

	Author:		Paul Olson
	                adapted from tufault.c by Mike Mattioli

	Creation Date:	15 June, 1999

	Contents:	fault list generator for network (*.dee) files
                        for faults at outputs
***************************************************************************/


#include <stdio.h>
#include <string.h>
#include "/home/mattioli/clibs/cslib/genlib.h"
#include "/home/mattioli/clibs/cslib/simpio.h"
#define NET_EXTENSION	".dee"
#define FAULT_EXTENSION	".fls"

int main(argc, argv) 

int argc;
char *argv[];

{		
	extern FILE           *fopen();
   	extern int            fclose();

	/*Variable Declarations*/
	int TRUE, junk, type, counter1, a, tab, counter2, fanout, fanin;
	int b,c,d,e,number_elems,skip,x,f,y,k,tally,new,cow;
	int happy, grumpy, sleepy, doc;
	int out_num, in_num, neg;
	FILE *infile, *outfile;
	string  lines, buffer, filename2;
	char filename[64],ch[3];
	TRUE=1;
	
	if (argc != 2)
   	{
      		printf ("Wrong number of arguments (1st: netlist).\n");
		printf ("Usage: tufault <network name>\n");
      		exit(4);
   	}

   	/* open the file containing the circuit description */
   	sprintf (filename, "%s%s", argv[1], NET_EXTENSION);
   	if ((infile = fopen (filename, "r")) == NULL)
   	{  
   	   printf ("Network file not found\n");
   	   exit(4);
   	}
 
   	
	/* open the output file */
   	sprintf (filename, "%s%s", argv[1], FAULT_EXTENSION);
   	if ((outfile = fopen (filename, "w")) == NULL)
   	{
   	   printf ("Error opening output file\n");
   	   exit(4);
   	}

	/* Finds line number of element description in dee file */ 
	for(counter1=0;counter1<21;counter1++) {
		ReadLine(infile);
	}	

	fscanf(infile, "%d", &tab);
	

	/*we are now on line 22. go to line 34 & scan elements*/
	for(counter1=22;counter1<34;counter1++) {
		ReadLine(infile);
	}
	fscanf(infile, "%d", &number_elems);

	/*still on line 34. now go to line 41+tab*/	
	for(counter1=34;counter1<(41+tab);counter1++) {
                ReadLine(infile);
        }
	
	/* we are now on the first line of the element topo section */
	/*uncomment the following lines to check your position:*/
	/*fscanf(infile, "%d", &tab);*/
	/*printf("first line, first number = %d\n",tab);*/
	/*printf("file name: %s",filename);*/
	/*printf("number of elements = %d\n",number_elems);*/
	/*printf("Ready to perform analysis...\n");*/	

	for(k=0;k<number_elems;k++) {

	/*scanning first line of element*/
	fscanf(infile,"%d %d", &a, &b);
	/*printf("%d,%d\n",a,b);*/

	lines=ReadLine(infile);
	fscanf(infile,"%d %d %d %d %d %d %d %d",&x,&y,&c,&d,&e,&f,&out_num,&in_num);

	/*if element is a wire, skip to next element*/
	if(b==1) {
		/*printf("element %d is a wire. Skipping...\n",k);*/
		for(counter1=0;counter1<(d+e+1);counter1++) {
			ReadLine(infile);
		}
	} else {
		/*printf("Element %d is a gate\n",k);*/
		
		/*if element is a gate, skip to the input section*/

		for(tally=0;tally<(e+1);tally++) {
			ReadLine(infile);
		}

		/*printf("%d\n",f);*/
		for(new=0;new<f;new++) {
			fscanf(infile,"%d %d %d %d",
			&happy,&grumpy,&sleepy,&doc);

			/*printf("%d %d %d %d\n",happy,grumpy,sleepy,doc);*/
			
			for(cow=0;cow<2;cow++) {

				fprintf(outfile,"%d %d 0 %d\n",
				cow,grumpy,k);
			}



		}
	}
	
}
fclose (infile);
fclose (outfile);      
printf ("fault list generated.\n");
}



